//
// memstr.h
//
// Copyright (C) 2014 Robert William Fuller <hydrologiccycle@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#ifndef MEMSTR_H_INCLUDED
#define MEMSTR_H_INCLUDED


#include <caulk/libcaulk_config.h> // LIBCAULK_HAVE_MEMRCHR

// _GNU_SOURCE must be defined before including any other headers
#if defined(LIBCAULK_HAVE_MEMRCHR) || defined(LIBCAULK_HAVE_MEMMEM)
#   ifndef _GNU_SOURCE // already defined for g++
#       define _GNU_SOURCE // memrchr, memmem
#   endif // _GNU_SOURCE
#endif
#include <string.h>


#ifndef LIBCAULK_HAVE_MEMRCHR
extern void *memrchr(const void *p, int c, size_t n);
#endif
#ifndef LIBCAULK_HAVE_MEMMEM
extern void *memmem(const void *str, size_t str_len, const void *sub, size_t sub_len);
#endif


#endif // MEMSTR_H_INCLUDED
