//
// memstr.c
//
// Copyright (C) 2014 Robert William Fuller <hydrologiccycle@gmail.com>
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include <caulk/memstr.h>


#ifndef LIBCAULK_HAVE_MEMRCHR

void *memrchr(const void *p, int c, size_t n)
{
    const char *s = (const char *) p;

    while (n--) {
        if (c == s[n]) {
            return (void *) &s[n];
        }
    }

    return NULL;
}

#endif // LIBCAULK_HAVE_MEMRCHR


#ifndef LIBCAULK_HAVE_MEMMEM

void *memmem(const void *str, size_t str_len, const void *sub, size_t sub_len)
{
    const char *cstr = (const char *) str;
    const char *csub = (const char *) sub;
    ssize_t n;

    for (n = str_len - sub_len;  n >= 0;  --n) {
        if (cstr[n] == csub[0] && !memcmp(&cstr[n], csub, sub_len)) {
            return (void *) &cstr[n];
        }
    }

    return NULL;
}

#endif // LIBCAULK_HAVE_MEMMEM
